// KeyboardStateLoader.cpp : Ӧóڵ㡣
//

#include "stdafx.h"
#include "KeyboardState.h"

// ȫֱ:
HINSTANCE _hInst = NULL;
HWND _hWnd = NULL;
NOTIFYICONDATA _nid = {0};
HICON _hIcons[4] = {0};
HHOOK _hHook = NULL;
HANDLE _hSingleton = NULL;


int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	MSG msg = {0};
	BOOL hasNotifyIcon = FALSE;

	if (HandleCommandLine(lpCmdLine))
		return 0;

	if (!CheckSingletonInst())
	{
		MessageBox(NULL, _T("ѾС"), WND_CLASS_NAME, MB_ICONINFORMATION);
		goto __End;
	}

	MyRegisterClass(hInstance);

	// ִӦóʼ:
	if (!InitInstance(hInstance))
	{
		MessageBox(NULL, _T("ʼʧ!"), WND_CLASS_NAME, MB_ICONERROR);
		goto __End;
	}

	HICON hIcon = GetCurrentIcon(0);
	_nid.cbSize = sizeof(NOTIFYICONDATA);
	_nid.hWnd = _hWnd;
	_nid.uID = 1028;
	_nid.uFlags = NIF_ICON | NIF_TIP;
	_nid.hIcon = hIcon;
	_tcscpy_s(_nid.szTip, 128, WND_CLASS_NAME);
	_tcscat_s(_nid.szTip, 128, _T(" by Qiuyi\nWin + F9˳"));

	hasNotifyIcon = Shell_NotifyIcon(NIM_ADD, &_nid);
	if (!hasNotifyIcon)
	{
		MessageBox(NULL, _T("޷֪ͨͼ!"), WND_CLASS_NAME, MB_ICONERROR);
		goto __End;
	}

	_hHook = SetWindowsHookEx(WH_KEYBOARD_LL, HookProc, hInstance, 0);
	if (_hHook == NULL)
	{
		MessageBox(NULL, _T("޷ü̼¼!"), WND_CLASS_NAME, MB_ICONERROR);
		goto __End;
	}

	hIcon = GetCurrentIcon(0);
	if (hIcon != _nid.hIcon)
	{
		_nid.hIcon = hIcon;
		Shell_NotifyIcon(NIM_MODIFY, &_nid);
	}

	// Ϣѭ:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

__End:
	if (_hHook != NULL)
		UnhookWindowsHookEx(_hHook);
	if (hasNotifyIcon)
		Shell_NotifyIcon(NIM_DELETE, &_nid);
	if (_hSingleton != NULL)
		CloseHandle(_hSingleton);

	return (int)msg.wParam;
}



//
//  : MyRegisterClass()
//
//  Ŀ: עᴰࡣ
//
//  ע:
//
//    ϣ
//    ˴ӵ Windows 95 еġRegisterClassEx
//    ֮ǰ Win32 ϵͳʱҪ˺÷ô˺ʮҪ
//    ӦóͿԻù
//    ʽȷġСͼꡣ
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex = {0};

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.hInstance		= hInstance;
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszClassName	= WND_CLASS_NAME;

	return RegisterClassEx(&wcex);
}

//
//   : InitInstance(HINSTANCE, int)
//
//   Ŀ: ʵ
//
//   ע:
//
//        ڴ˺Уȫֱбʵ
//        ʾ򴰿ڡ
//
BOOL InitInstance(HINSTANCE hInstance)
{
   _hInst = hInstance; // ʵ洢ȫֱ

   _hWnd = CreateWindow(WND_CLASS_NAME, _T(""), WS_OVERLAPPED | WS_CAPTION,
      0, 0, 1, 1, NULL, NULL, hInstance, NULL);

   if (!_hWnd)
      return FALSE;
   return TRUE;
}

//
//  : WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  Ŀ: ڵϢ
//
//  WM_COMMAND	- Ӧó˵
//  WM_PAINT	- 
//  WM_DESTROY	- ˳Ϣ
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_COMMAND:
		break;
	case WM_PAINT:
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

HICON GetIcon(int type)
{
	HICON hIcon = NULL;

	switch (type)
	{
	case ICON_CAPS_ON:
		if (_hIcons[0] == NULL)
			_hIcons[0] = LoadIcon(_hInst, MAKEINTRESOURCE(IDI_ICON1));
		hIcon = _hIcons[0];
		break;
	case ICON_CAPS_ON_NUM:
		if (_hIcons[1] == NULL)
			_hIcons[1] = LoadIcon(_hInst, MAKEINTRESOURCE(IDI_ICON3));
		hIcon = _hIcons[1];
		break;
	case ICON_CAPS_OFF:
		if (_hIcons[2] == NULL)
			_hIcons[2] = LoadIcon(_hInst, MAKEINTRESOURCE(IDI_ICON2));
		hIcon = _hIcons[2];
		break;
	case ICON_CAPS_OFF_NUM:
		if (_hIcons[3] == NULL)
			_hIcons[3] = LoadIcon(_hInst, MAKEINTRESOURCE(IDI_ICON4));
		hIcon = _hIcons[3];
		break;
	}

	return hIcon;
}

HICON GetCurrentIcon(DWORD vkCode)
{
	bool numLock = (GetKeyState(VK_NUMLOCK) & 1) == (SHORT)(vkCode != VK_NUMLOCK);
	bool capital = (GetKeyState(VK_CAPITAL) & 1) == (SHORT)(vkCode != VK_CAPITAL);

	if (capital)
	{
		if (numLock)
			return GetIcon(ICON_CAPS_ON_NUM);
		else
			return GetIcon(ICON_CAPS_ON);
	}
	else
	{
		if (numLock)
			return GetIcon(ICON_CAPS_OFF_NUM);
		else
			return GetIcon(ICON_CAPS_OFF);
	}
}

LRESULT CALLBACK HookProc(int code, WPARAM wParam, LPARAM lParam)
{
	if (code == HC_ACTION && (DWORD)wParam == WM_KEYDOWN)
	{
		DWORD vkCode = ((PKBDLLHOOKSTRUCT)lParam)->vkCode;
		if (vkCode == VK_CAPITAL || vkCode == VK_NUMLOCK)
		{
			_nid.hIcon = GetCurrentIcon(vkCode);
			Shell_NotifyIcon(NIM_MODIFY, &_nid);
		}
		else if (vkCode == VK_F9)
		{
			// Left Win + F9 ˳
			if (GetKeyState(VK_LWIN) & 0x8000)
			{
				PostQuitMessage(0);
				return TRUE;
			}
		}
	}
	return CallNextHookEx(_hHook, code, wParam, lParam);
}

bool CheckSingletonInst()
{
	_hSingleton = CreateMutex(NULL, TRUE, _T("fca5ecb61cd1417c8aa756d14fff2df6"));
	bool bFound = (GetLastError() == ERROR_ALREADY_EXISTS);
	if (_hSingleton != NULL)
		ReleaseMutex(_hSingleton);
	return !bFound;
}

void ShowWin32ErrorMsg(LSTATUS result)
{
	LPTSTR pBuf = (LPTSTR)calloc(65536, sizeof(TCHAR));
	if (pBuf != NULL)
	{
		DWORD dwLen = FormatMessage(FORMAT_MESSAGE_ARGUMENT_ARRAY | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 
			NULL, result, 0, pBuf, 65536, NULL);
		if (dwLen > 0)
			MessageBox(NULL, pBuf, WND_CLASS_NAME, MB_ICONERROR);
		else
			MessageBox(NULL, _T("δ֪!"), WND_CLASS_NAME, MB_ICONERROR);

		free(pBuf);
	}
}

void Install()
{
	HKEY hKey = NULL;
	LSTATUS result = RegCreateKeyEx(HKEY_LOCAL_MACHINE, RUN_REG_SUBKEY, 0, NULL, 
		REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, NULL);

	if (result == ERROR_SUCCESS)
	{
		TCHAR processPath[MAX_PATH] = {0};
		DWORD dwLen = GetModuleFileName(NULL, processPath, MAX_PATH);
		//result = RegSetKeyValue(hKey, NULL, WND_CLASS_NAME, REG_SZ, processPath, (dwLen + 1) * sizeof(TCHAR));
		result = RegSetValueEx(hKey, WND_CLASS_NAME, 0, REG_SZ, (BYTE*)processPath, (dwLen + 1) * sizeof(TCHAR));

		RegCloseKey(hKey);

		if (result == ERROR_SUCCESS)
		{
			MessageBox(NULL, _T("װɹ"), WND_CLASS_NAME, MB_ICONINFORMATION);
			return;
		}
	}
	else if (result == ERROR_ACCESS_DENIED)
	{
		MessageBox(NULL, _T("װʧ! ԹԱݽаװ."), WND_CLASS_NAME, MB_ICONERROR);
		return;
	}

	ShowWin32ErrorMsg(result);
}

void Uninstall()
{
	HKEY hKey = NULL;
	LSTATUS result = RegOpenKeyEx(HKEY_LOCAL_MACHINE, RUN_REG_SUBKEY, 0, KEY_SET_VALUE, &hKey);

	if (result == ERROR_SUCCESS)
	{
		result = RegDeleteValue(hKey, WND_CLASS_NAME);
		RegCloseKey(hKey);
	}
	else if (result == ERROR_ACCESS_DENIED)
	{
		MessageBox(NULL, _T("жʧ! ԹԱݽж."), WND_CLASS_NAME, MB_ICONERROR);
		return;
	}

	if (result == ERROR_SUCCESS || result == ERROR_FILE_NOT_FOUND)
	{
		MessageBox(NULL, _T("жسɹ"), WND_CLASS_NAME, MB_ICONINFORMATION);
		return;
	}

	ShowWin32ErrorMsg(result);
}

BOOL HandleCommandLine(LPTSTR lpCmdLine)
{
	if (lpCmdLine != NULL && lpCmdLine[0] != _T('\0'))
	{
		int nArgs = 0;
		LPTSTR *szArglist = CommandLineToArgvW(lpCmdLine, &nArgs);

		if (szArglist != NULL)
		{
			LPTSTR pStr = NULL;
			for (int i = 0; i < nArgs; i++)
			{
				pStr = szArglist[i];
				if (lstrcmpi(pStr, _T("--install")) == 0)	// װ
				{
					Install();
					return TRUE;
				}
				else if (lstrcmpi(pStr, _T("--uninstall")) == 0)	 // ж
				{
					Uninstall();
					return TRUE;
				}
			}

			LocalFree(szArglist);
		}
	}

	return FALSE;
}